﻿Imports System.Windows.Forms

Public Class PatientDialog

    Private _PatientAModifier As Patient
    Dim currentNbCheckedBox As Integer
    Dim prioriteBilan As Integer

    Sub New(ByVal PatientAModifier As Patient)
        ' Cet appel est requis par le concepteur.
        InitializeComponent()
        ' Ajoutez une initialisation quelconque après l'appel InitializeComponent().
        'Récupère le film à modifier
        _PatientAModifier = PatientAModifier
    End Sub
    Private Sub PatientDialog_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        If _PatientAModifier Is Nothing Then
            'S'il ne contient rien, on en crée un nouveau
            'coche priorite moyenne par defaut
            Me.MoyPrioRB.Checked = True
        Else
            'Sinon on recupère les infos 
            Me.NewP_Nom_TextBox.Text = _PatientAModifier.Nom
            Me.NewP_Prenom_TextBox.Text = _PatientAModifier.Prenom
            prioriteBilan = _PatientAModifier.Priorite
            If prioriteBilan = 1 Then
                ImpPrioRB.Checked = True
            ElseIf prioriteBilan = 2 Then
                MoyPrioRB.Checked = True
            ElseIf prioriteBilan = 3 Then
                FaiblePrioRB.Checked = True
            ElseIf prioriteBilan = 4 Then
                NA_RB.Checked = True
            End If
            Me.NewP_DateTimePicker.Value = _PatientAModifier.DateConsult
            Me.NotesTextBox.Text = _PatientAModifier.Notes
            Me.CheckBoxQuest.Checked = _PatientAModifier.QuestionnairesOK
            Me.CheckBoxAnamn.Checked = _PatientAModifier.AnamneseOK
            Me.CheckBoxComprt.Checked = _PatientAModifier.ComportementOK
            Me.CheckBoxCotat.Checked = _PatientAModifier.CotationOK
            Me.CheckBoxWIaTE.Checked = _PatientAModifier.WISCaTeachOK
            Me.CheckBoxTEaRE.Checked = _PatientAModifier.TEACHaReyOK
            Me.CheckBox7Ccl.Checked = _PatientAModifier.CclConseilsOK
            Me.CheckBoxAmena.Checked = _PatientAModifier.AmenagementsOK
            Me.CheckBoxCRparent.Checked = _PatientAModifier.CRparentsOK
            Me.CheckBoxCRpro.Checked = _PatientAModifier.CRproOK
        End If

    End Sub

    Private Sub OK_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OK_Button.Click

        If Me.NewP_Nom_TextBox.Text = "" Or Me.NewP_Prenom_TextBox.Text = "" Then
            MsgBox("Renseignez au minimum un Nom et un Prenom", vbOKOnly, "Confirmation")
        Else
            If _PatientAModifier Is Nothing Then
                'Enregistre nouveau patient
                Dim NPatient As New Patient(Me.NewP_Nom_TextBox.Text, Me.NewP_Prenom_TextBox.Text, Me.NewP_DateTimePicker.Value, prioriteBilan, Me.NotesTextBox.Text, Me.CheckBoxQuest.Checked, Me.CheckBoxAnamn.Checked, Me.CheckBoxComprt.Checked, Me.CheckBoxCotat.Checked, Me.CheckBoxWIaTE.Checked, Me.CheckBoxTEaRE.Checked, Me.CheckBox7Ccl.Checked, Me.CheckBoxAmena.Checked, Me.CheckBoxCRparent.Checked, Me.CheckBoxCRpro.Checked, currentNbCheckedBox)
                'On l'ajoute à la liste
                FenetreListePatient.ListePatients.Add(NPatient)
                'MsgBox("Patient correctement crée", vbOKOnly, "Confirmation")
            Else
                'Sinon on le modifie en récupérant son index dans la liste de la fenêtre parent
                FenetreListePatient.ListePatients(FenetreListePatient.ListePatients.IndexOf(_PatientAModifier)).Update(Me.NewP_Nom_TextBox.Text, Me.NewP_Prenom_TextBox.Text, Me.NewP_DateTimePicker.Value, prioriteBilan, Me.NotesTextBox.Text, Me.CheckBoxQuest.Checked, Me.CheckBoxAnamn.Checked, Me.CheckBoxComprt.Checked, Me.CheckBoxCotat.Checked, Me.CheckBoxWIaTE.Checked, Me.CheckBoxTEaRE.Checked, Me.CheckBox7Ccl.Checked, Me.CheckBoxAmena.Checked, Me.CheckBoxCRparent.Checked, Me.CheckBoxCRpro.Checked, currentNbCheckedBox)
                'MsgBox("Patient correctement mis à jour", vbOKOnly, "Confirmation")
            End If
            'MAJ de la liste dans la fenêtre parent
            FenetreListePatient.UpdateListe()

            Me.DialogResult = System.Windows.Forms.DialogResult.OK
            Me.Close()
        End If

        

    End Sub

    Private Sub Cancel_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Cancel_Button.Click
        Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.Close()
    End Sub

    Private Sub TimerCheckBox_Tick(sender As System.Object, e As System.EventArgs) Handles TimerCheckBox.Tick
        currentNbCheckedBox = 0
        If Me.CheckBoxQuest.Checked Then
            currentNbCheckedBox = currentNbCheckedBox + 10
        End If
        If Me.CheckBoxAnamn.Checked Then
            currentNbCheckedBox = currentNbCheckedBox + 10
        End If
        If Me.CheckBoxComprt.Checked Then
            currentNbCheckedBox = currentNbCheckedBox + 10
        End If
        If Me.CheckBoxCotat.Checked Then
            currentNbCheckedBox = currentNbCheckedBox + 10
        End If
        If Me.CheckBoxWIaTE.Checked Then
            currentNbCheckedBox = currentNbCheckedBox + 10
        End If
        If Me.CheckBoxTEaRE.Checked Then
            currentNbCheckedBox = currentNbCheckedBox + 10
        End If
        If Me.CheckBox7Ccl.Checked Then
            currentNbCheckedBox = currentNbCheckedBox + 10
        End If
        If Me.CheckBoxAmena.Checked Then
            currentNbCheckedBox = currentNbCheckedBox + 10
        End If
        If Me.CheckBoxCRparent.Checked Then
            currentNbCheckedBox = currentNbCheckedBox + 10
        End If
        If Me.CheckBoxCRpro.Checked Then
            currentNbCheckedBox = currentNbCheckedBox + 10
        End If

        Me.LabelPerc.Text = currentNbCheckedBox & " %"
        Me.ProgressBarDialog.Value = currentNbCheckedBox

        If FaiblePrioRB.Checked Then
            prioriteBilan = 3
        ElseIf MoyPrioRB.Checked Then
            prioriteBilan = 2
        ElseIf ImpPrioRB.Checked Then
            prioriteBilan = 1
        ElseIf NA_RB.Checked Then
            prioriteBilan = 4
        Else
            prioriteBilan = 0
        End If

        If currentNbCheckedBox = 100 Then
            prioriteBilan = 4
        End If

        If DateTime.Compare(Me.NewP_DateTimePicker.Value.ToShortDateString, Date.Now.ToShortDateString) > 0 Then
            prioriteBilan = 4
            ImpPrioRB.Enabled = False
            FaiblePrioRB.Enabled = False
            MoyPrioRB.Enabled = False
            NA_RB.Checked = True
        Else
            ImpPrioRB.Enabled = True
            FaiblePrioRB.Enabled = True
            MoyPrioRB.Enabled = True
        End If


    End Sub

    Private Sub ButtonToutCocher_Click(sender As System.Object, e As System.EventArgs) Handles ButtonToutCocher.Click
        Me.CheckBoxQuest.Checked = True
        Me.CheckBoxAnamn.Checked = True
        Me.CheckBoxComprt.Checked = True
        Me.CheckBoxCotat.Checked = True
        Me.CheckBoxWIaTE.Checked = True
        Me.CheckBoxTEaRE.Checked = True
        Me.CheckBox7Ccl.Checked = True
        Me.CheckBoxAmena.Checked = True
        Me.CheckBoxCRparent.Checked = True
        Me.CheckBoxCRpro.Checked = True
    End Sub

    Private Sub ButtonDecochTout_Click(sender As System.Object, e As System.EventArgs) Handles ButtonDecochTout.Click
        Me.CheckBoxQuest.Checked = False
        Me.CheckBoxAnamn.Checked = False
        Me.CheckBoxComprt.Checked = False
        Me.CheckBoxCotat.Checked = False
        Me.CheckBoxWIaTE.Checked = False
        Me.CheckBoxTEaRE.Checked = False
        Me.CheckBox7Ccl.Checked = False
        Me.CheckBoxAmena.Checked = False
        Me.CheckBoxCRparent.Checked = False
        Me.CheckBoxCRpro.Checked = False
    End Sub
End Class
